# -*- coding: utf-8 -*-
# Name:        Moon2 test polygone
# version
# Author:      akzami
# Created:     10.06.2013
# Copyright:   (c) mnc 2013
#-------------------------------------------------------------------------------
#!/usr/bin/env python
from    pandac.PandaModules             import *
from    direct.interval.IntervalGlobal  import *
from    direct.showbase.DirectObject    import DirectObject
from    menus                           import *


mask_a=BitMask32.bit(1)     #BitMask32(0x00000001)
mask_b=BitMask32.bit(2)     #BitMask32.allOff()
mask_c=BitMask32.bit(3)


class collider2(DirectObject):
    def __init__(self,x=0,y=0,z=0):
        self.state=1

        self.geomt= 0
        self.acp =(0,0,0) # active cell point
        self.acn =(0,0,0) # active cell normal
        self.acs=False    #status :True=cell is highlighted

        #self.picker = CollisionTraverser()            #Make a traverser
        #self.pq     = CollisionHandlerQueue()         #Make a handler

        base.cTrav = CollisionTraverser()
        self.collHandler = CollisionHandlerQueue()

        pickerCollN         = CollisionNode('mouseRay')
        self.pickerCamN     = base.camera.attachNewNode(pickerCollN)
        pickerCollN.setFromCollideMask(BitMask32.bit(1))
        pickerCollN.setIntoCollideMask(BitMask32.allOff())
        self.pickerRay      = CollisionRay()
        pickerCollN.addSolid(self.pickerRay)
        NodePath(pickerCollN).show()
        base.cTrav.addCollider(self.pickerCamN, self.collHandler)
        self.makecq(x,y,z)
        self.cnpquad    =render.attachNewNode(CollisionNode('cnquad'))

        self.cnpquad.node().addSolid(self.qto)
        self.cnpquad.node().addSolid(self.qbo)
        self.cnpquad.node().addSolid(self.qle)
        self.cnpquad.node().addSolid(self.qri)
        self.cnpquad.node().addSolid(self.qfr)
        self.cnpquad.node().addSolid(self.qba)
        self.cnpquad.node().setCollideMask(BitMask32.bit(1))
        self.cnpquad.show()
        base.taskMgr.add(self.mouseTask2, 'ray_task')


    def destroy(self):

        self.cnpquad.removeNode()
        base.cTrav.clearColliders()
    def mouseTask2(self,task):
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse()
            self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
            if self.collHandler.getNumEntries() > 0:
                self.state=2
                self.collHandler.sortEntries()
                entry = self.collHandler.getEntry(0)
                self.acp = entry.getSurfacePoint(render)
                self.acn = entry.getSurfaceNormal(render)
            else :
                self.state=1
        return task.cont

    def makecq(self,x=0,y=0,z=0):
        #left side
        self.qle =CollisionPolygon(Point3(x, y, z), Point3(x, y, z+1),
                                    Point3(x, y+1, z+1), Point3(x, y+1, z))
        #front side
        self.qfr=CollisionPolygon(Point3(x+1, y, z), Point3(x+1, y, z+1),
                                    Point3(x, y, z+1), Point3(x, y, z))
        #right
        self.qri =CollisionPolygon(Point3(x+1, y+1, z), Point3(x+1, y+1, z+1),
                                    Point3(x+1, y, z+1), Point3(x+1, y, z))
        #back side
        self.qba =CollisionPolygon(Point3(x, y+1, z), Point3(x, y+1, z+1),
                                    Point3(x+1, y+1, z+1), Point3(x+1, y+1, z))
        #top side
        self.qto=CollisionPolygon(Point3(x, y, z+1), Point3(x+1, y, z+1),
                                    Point3(x+1, y+1, z+1), Point3(x, y+1, z+1))
        #bottom
        self.qbo =CollisionPolygon(Point3(x, y, z), Point3(x, y+1, z),
                                    Point3(x+1, y+1, z), Point3(x+1, y, z))
class collider(DirectObject):
    def __init__(self):
        self.name="collider"
        self.geomt= 0

        base.cTrav=CollisionTraverser()
        self.collisionHQ = CollisionHandlerQueue()

        self.traverser = CollisionTraverser()
        self.handler = CollisionHandlerQueue()


        self.mouseTask  = taskMgr.add(self.mouseTask, 'mouseTask')
        self.acp =(0,0,0) # active cell point
        self.acn =(0,0,0) # active cell normal
        self.acs=False    #status :True=cell is highlighted

        self.makecq()

        self.cnpquad    =render.attachNewNode(CollisionNode('cnquad'))
        self.cnpquad.node().addSolid(self.qto)
        self.cnpquad.node().addSolid(self.qbo)
        self.cnpquad.node().addSolid(self.qle)
        self.cnpquad.node().addSolid(self.qri)
        self.cnpquad.node().addSolid(self.qfr)
        self.cnpquad.node().addSolid(self.qba)

        base.cTrav=CollisionTraverser()
        collisionHandler = CollisionHandlerEvent()

        pickerNode=CollisionNode('mouseraycnode')
        self.pickerNP=base.camera.attachNewNode(pickerNode)
        self.pickerRay=CollisionRay()
        pickerNode.addSolid(self.pickerRay)
        base.cTrav.addCollider(self.pickerNP, collisionHandler)
        self.collisionHandler=collisionHandler


        collisionHandler.addInPattern('%fn-into-%in')
        collisionHandler.addOutPattern('%fn-out-%in')

        self.accept('mouseraycnode-into-cnquad', self.collideEventIn)
        self.accept('mouseraycnode-out-cnquad', self.collideEventOut)
        self.pickingEnabled=False
        self.accept('mouse1', self.mousePick, ['down'])
        self.accept('mouse1-up', self.mousePick, ['up'])

    def makecq(self):
        x=0
        y=0
        z=0
        #left side
        self.qle =CollisionPolygon(Point3(x, y, z), Point3(x, y, z+1),
                                    Point3(x, y+1, z+1), Point3(x, y+1, z))
        #front side
        self.qfr=CollisionPolygon(Point3(x+1, y, z), Point3(x+1, y, z+1),
                                    Point3(x, y, z+1), Point3(x, y, z))
        #right
        self.qri =CollisionPolygon(Point3(x+1, y+1, z), Point3(x+1, y+1, z+1),
                                    Point3(x+1, y, z+1), Point3(x+1, y, z))
        #back side
        self.qba =CollisionPolygon(Point3(x, y+1, z), Point3(x, y+1, z+1),
                                    Point3(x+1, y+1, z+1), Point3(x+1, y+1, z))
        #top side
        self.qto=CollisionPolygon(Point3(x, y, z+1), Point3(x+1, y, z+1),
                                    Point3(x+1, y+1, z+1), Point3(x, y+1, z+1))
        #bottom
        self.qbo =CollisionPolygon(Point3(x, y, z), Point3(x, y+1, z),
                                    Point3(x+1, y+1, z), Point3(x+1, y, z))
    def mouseTask(self,task):
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse()
            self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())

            self.menu.text[0]=str(mpos.getX())
            self.menu.text[1]=str(mpos.getY())
            base.cTrav.traverse(self.pickerNP)
            self.collisionHQ.sortEntries()


        return task.cont

def main():
    pass

if __name__ == '__main__':
    main()
