# -*- coding: utf-8 -*-
# Name:        Moon2 test polygone
# version
# Author:      akzami
# Created:     13.06.2013
# Copyright:   (c) mnc 2013
#-------------------------------------------------------------------------------
#!/usr/bin/env python
from    panda3d.core import *
from    direct.particles.ParticleEffect import ParticleEffect
from    direct.filter.FilterManager     import FilterManager

class e_fire():
    def __init__(self,x=0,y=0,z=0):
        self.x=x
        self.y=y
        self.z=z
        self.ready      = False
        base.enableParticles()
        self.make_test_scene()
        self.setup_lights(render)
        heat_root = NodePath('heat particles root')
        self.filter(*self.setup_FBR(heat_root))
        p = ParticleEffect()
        p.loadConfig('shd/ptf/heat.ptf')
        p.start(parent = heat_root, renderParent = heat_root)
        p.setPos(self.x, self.y, self.z)
    def make_test_scene(self):
        pv = ParticleEffect()
        pv.loadConfig('shd/ptf/smoke.ptf')
        pv.start(render)
        pv.setPos(self.x, self.y, self.z)
        pv.setDepthWrite(False)
        pv.setBin("fixed", 0)
        ps = ParticleEffect()
        ps.loadConfig('shd/ptf/spark.ptf')
        ps.start(render)
        ps.setPos(self.x, self.y, self.z)
        ps.setScale(3)
        ps.setLightOff()
        pf = ParticleEffect()
        pf.loadConfig('shd/ptf/fire.ptf')
        pf.start(render)
        pf.setPos(self.x, self.y, self.z+.5)
        pf.setLightOff()
        pf.setDepthWrite(False)
        pf.setBin("fixed", 0)
        pf.setScale(0.6)
    def setup_lights(self,root):
        ambientLight = AmbientLight("ambientLight")
        ambientLight.setColor(Vec4(.6, .6, .5, 1))
        directionalLight = DirectionalLight("directionalLight")
        directionalLight.setDirection(Vec3( 0, 8, -2.5 ) )
        directionalLight.setColor(Vec4( 0.9, 0.8, 0.9, 1 ) )
        root.setLight(root.attachNewNode(directionalLight))
        root.setLight(root.attachNewNode(ambientLight))
    def setup_FBR(self,root):
        ldepthmap = Texture()
        ldepthmap.setFormat( Texture.FDepthComponent )
        #ldepthmap.setComponentType( Texture.TFloat )
        props = FrameBufferProperties()
        props.setRgbColor(1)
        props.setDepthBits(1)
        mybuffer = base.win.makeTextureBuffer("My Buffer",
                                              base.win.getXSize(),
                                              base.win.getYSize(),
                                              to_ram = False,
                                              tex = ldepthmap,
                                              fbp = props)
        mybuffer.setClearColor(Vec4(0,0,0,1))
        mybuffer.setSort(-100)
        mycamera = base.makeCamera(mybuffer, scene = root)
        mycamera.reparentTo(camera)

        distortmap = Texture()
        mybuffer.addRenderTexture(distortmap,
           GraphicsOutput.RTMBindOrCopy,
           GraphicsOutput.RTPColor)

        return distortmap, ldepthmap
    def filter(self,dist, depth):
        manager = FilterManager(base.win, base.cam)
        mcolor = Texture()
        mdepth = Texture()
        finalquad = manager.renderSceneInto(colortex = mcolor, depthtex = mdepth)
        finalquad.setShader(Shader.load("shd/heat_shader.sha"))
        finalquad.setShaderInput("color", mcolor)
        finalquad.setShaderInput("distort", dist)
        finalquad.setShaderInput("depth", depth)
        finalquad.setShaderInput("maindepth", mdepth)


def main():
    pass

if __name__ == '__main__':
    main()
