# -*- coding: utf-8 -*-
# Name              : Moon2 polygone
# version           : read changelog.txt
# Author            : akzami
# this file created : 28.04.2013
# Copyright         : (c) akzami 2013
#-------------------------------------------------------------------------------
# основной файл
#
#-------------------------------------------------------------------------------

from    pandac.PandaModules             import *
from    direct.task.Task                import Task
from    panda3d.core                    import NodePath
from    direct.showbase.DirectObject    import DirectObject
from    direct.interval.IntervalGlobal  import *
from    direct.particles.ParticleEffect import ParticleEffect
from    direct.filter.FilterManager     import FilterManager
from    menus                           import *
from    collisions                      import *
from    g6                              import *
from    effects                         import *
import  direct.directbase.DirectStart
import  sys
#from    panda3d.bullet                  import BulletDebugNode

class Game(DirectObject):
    def __init__(self,workdir):
        self.ready      = False
        self.workdir    = workdir

        self.menu       = S_hint()
        self.menu.showmenu()
        self.menu.debugConsole()

        self.geomt= 0
        self.picks= 0
        #base.disableMouse()


        #base.camera.setPos(-15,-15,15)
        #base.camera.lookAt(5, 5, 5)

        self.accept('escape', sys.exit)
        self.accept('f5'    , self.doScreenshot)
        self.accept('g', self.togglegeom)
        self.accept('b', self.addcube)
        #self.accept('d', self.toggleDebug)
        self.accept('x', self.toggle_wire)

        #self.fire =e_fire(-2,-2,2)# факел
        self.collider=collider2()

        self.chest =loader.loadModel("dat/mdl/chest/chest.egg")
        #self.actor.reparentTo(render)
        self.chest.setScale(0.01)
        self.chest.setPos(3,0,0)
        lod = LODNode('my LOD node')
        lod_np = NodePath(lod)
        lod_np.reparentTo(render)
        lod.addSwitch(20.0, 0.0)
        self.chest.reparentTo(lod_np)
        """
        self.actor2 =loader.loadModel("dat/mdl/olderbrother/olderbrother.egg")
        self.actor2.reparentTo(render)
        self.actor2.setScale(0.34)
        self.actor2.setPos(0.5,0.5,0)
        """

        taskMgr.doMethodLater(0.5, self.updatehint, 'hinttask')
        self.updxyz()
    def updatehint(self, task):
        self.menu.text[2]=str( self.collider.acp)
        self.menu.text[3]=str( self.collider.acn)
        self.updxyz()
        #self.actor2.setPos(self.nx+.5,self.ny+.5,self.nz)

        self.chest.setPos(self.x+.5,self.y+.5,self.z)
        task.delayTime = .25
        return task.again
    def updxyz(self):
        self.nx=self.collider.acn[0]+0
        self.ny=self.collider.acn[1]+0
        self.nz=self.collider.acn[2]+0
        self.x=round(self.collider.acp[0],-1)+self.nx
        self.y=round(self.collider.acp[1],-1)+self.ny
        self.z=round(self.collider.acp[2],-1)+self.nz
        self.menu.text[4]=str(self.x)+" "+str(self.y)+" "+str(self.z)
    def addcube(self):
        #if self.collider.state==2:

        #self.updxyz()
        self.collider.cnpquad.removeNode()
        self.collider.pickerCamN.removeNode()

        self.n          =G8(path=self.workdir)
        self.n.mkbox(self.x,self.y,self.z,[1,7,7,7,7,7])
        self.n.close()
        self.nn= render.attachNewNode(self.n.node)
        #
        #self.collider.cnpquad.detachNode()

        self.nn.removeNode()
        self.collider=collider2(self.x,self.y,self.z)
        self.menu.text[5]=str(self.collider.cnpquad.node())

    def toggleC(self):
                self.collider.destroy()

    def togglegeom(self):
        #self.collider.menu.text[3]=str(self.geomt)
        if self.geomt==2:
            self.gn.removeNode()
            self.geomt=1
        else:
            self.g          =G8(path=self.workdir)
            self.g.mkbox(-2,0,0,[1,1,1,8,8,8])
            for a in xrange(0,15):
                for b in xrange(0,15):
                    self.g.rand(a,b)
            self.g.close()
            self.gn= render.attachNewNode(self.g.node)
            self.geomt=2

            #self.g.rand2()
    def movcam(self):
        base.cam.setX(5)

    def toggleG(self):
        try:
            self.g.hide()
        except:
            print "not work"
        pass
    def toggle_wire(self):
        base.toggleWireframe()
        base.toggleTexture()
    def watchto(self,x,y,z,h=0,p=0):
        base.cam.lookAt(x,y,z)
        #base.cam.setHPR(h,p,0)
    def createpickgeom(self):
        self.pg=render.attachNewNode
    def doScreenshot(self):
        base.screenshot("sst/moon2")
